Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.gradle.api
Interface Task

All Superinterfaces:
  java.lang.Comparable<Task>

All Known Implementing Classes:
  AbstractJettyRunTask, AbstractJettyRunWarTask, AbstractReportTask, org.gradle.api.internal.AbstractTask, AntTarget, Checkstyle, Clean, CodeNarc, Compile, org.gradle.api.internal.ConventionTask, Copy, org.gradle.api.DefaultTask, DependencyReportTask, EclipseClasspath, EclipseClean, EclipseProject, EclipseWtp, EclipseWtpModule, GroovyCompile, Groovydoc, Javadoc, JettyRun, JettyRunWar, JettyStop, PropertyReportTask, ScalaCompile, ScalaDefine, ScalaDoc, SourceTask, TaskReportTask, Test, Upload, Wrapper

    public interface Task

extends java.lang.Comparable<Task>

A `Task` represents a single step of a build, such as compiling classes or generating javadoc.

Each task belongs to a `Project`. You can use the various methods on `TaskContainer` to create and lookup task instances. For example, `TaskContainer.add(String)` creates an empty task with the given name. You can also use the `task` keyword in your build file:

     task myTask
     task myTask { configure closure }
     task myType << { task action }
     task myTask(type: SomeType)
     task myTask(type: SomeType) { configure closure }

Each task has a name, which can be used to refer to the task within its owning project, and a fully qualified path, which is unique across all tasks in all projects. The path is the concatenation of the owning project's path and the task's name. Path elements are separated using the ":" character.

### Task Actions

A `Task` is made up of a sequence of `TaskAction` objects. When the task is executed, each of the actions is executed in turn, by calling `Action.execute(T)`. You can add actions to a task by calling `doFirst(Action)` or `doLast(Action)`.

Groovy closures can also be used to provide a task action. When the action is executed, the closure is called with the task as parameter. You can add action closures to a task by calling `doFirst(groovy.lang.Closure)` or `doLast(groovy.lang.Closure)` or using the left-shift << operator.

There are 2 special exceptions which a task action can throw to abort execution and continue without failing the build. A task action can abort execution of the action and continue to the next action of the task by throwing a `StopActionException`. A task action can abort execution of the task and continue to the next task by throwing a `StopExecutionException`. Using these exceptions allows you to have precondition actions which skip execution of the task, or part of the task, if not true.

### Dependencies

A task may have dependencies on other tasks. Gradle ensures that tasks are executed in dependency order, so that the dependencies of a task are executed before the task is executed. You can add dependencies to a task using `dependsOn(Object...)` or `setDependsOn(Iterable)`. You can add objects of any of the following types as a dependency:

- A `String` task path or name. A relative path is interpreted relative to the task's `Project`. This allows you to refer to tasks in other projects.
- A `Task`.
- A closure. The closure may take a `Task` as parameter. It may return any of the types listed here. Its return value is recursively converted to tasks. A `null` return value is treated as an empty collection.
- A `TaskDependency` object.
- A `Buildable` object.
- A `Collection`, `Map` or an array. May contain any of the types listed here. The elements of the collection/map/array are recursively converted to tasks.
- A `Callable`. The `call()` method may return any of the types listed here. Its return value is recursively converted to tasks. A `null` return value is treated as an empty collection.
- An `Object`. The object's `toString()` method is interpreted as a task path or name.

### Using a Task in a Build File

#### Dynamic Properties

A `Task` has 3 'scopes' for properties. You can access these properties by name from the build file or by calling the `property(String)` method.

- The `Task` object itself. This includes any property getters and setters declared by the `Task` implementation class. The properties of this scope are readable or writable based on the presence of the corresponding getter and setter methods.
- The additional properties of the task. Each task object maintains a map of additional properties. These are arbitrary name -> value pairs which you can use to dynamically add properties to a task object. The properties of this scope are readable and writable.
- The convention properties added to the task by each `Plugin` applied to the project. A `Plugin` can add properties and methods to a task through the task's `Convention` object. The properties of this scope may be readable or writable, depending on the convention objects.

#### Dynamic Methods

A `Plugin` may add methods to a `Task` using its `Convention` object.

Field Summary
`static java.lang.String` | `AUTOSKIP_PROPERTY_PREFIX`
`static java.lang.String` | `TASK_ACTION`
`static java.lang.String` | `TASK_DEPENDS_ON`
`static java.lang.String` | `TASK_DESCRIPTION`
`static java.lang.String` | `TASK_NAME`
`static java.lang.String` | `TASK_OVERWRITE`
`static java.lang.String` | `TASK_TYPE`

Method Summary
`Task` | `captureStandardOutput(LogLevel level)` Enables redirection of standard output during task execution to the logging system.
`Task` | `configure(groovy.lang.Closure configureClosure)` Applies the statements of the closure against this task object.
`Task` | `deleteAllActions()` Removes all the actions of this task.
`Task` | `dependsOn(java.lang.Object... paths)` Adds the given dependencies to this task.
`boolean` | `dependsOnTaskDidWork()` Checks if any of the tasks that this task depends on `didWork`.
`Task` | `disableStandardOutputCapture()` Disables redirection of standard output during task execution.
`Task` | `doFirst(Action<? super Task> action)` Adds the given `TaskAction` to the beginning of this task's action list.
`Task` | `doFirst(groovy.lang.Closure action)` Adds the given closure to the beginning of this task's action list.
`Task` | `doLast(Action<? super Task> action)` Adds the given `TaskAction` to the end of this task's action list.
`Task` | `doLast(groovy.lang.Closure action)` Adds the given closure to the end of this task's action list.
`java.util.List<Action<? super Task>>` | `getActions()` Returns the sequence of `TaskAction` objects which will be executed by this task, in the order of execution.
`AntBuilder` | `getAnt()` Returns the `AntBuilder` for this task.
`Convention` | `getConvention()` Returns the `Convention` object for this task.
`java.util.Set<java.lang.Object>` | `getDependsOn()` Returns the dependencies of this task.
`java.lang.String` | `getDescription()` Returns the description of a task.
`boolean` | `getDidWork()` Checks if the task actually did any work.
`boolean` | `getEnabled()` Returns if this task is enabled or not.
`boolean` | `getExecuted()` Returns true if this task has been executed.
`Logger` | `getLogger()` Returns the logger for this task.
`java.lang.String` | `getName()` Returns the name of this task.
`org.gradle.execution.OutputHandler` | `getOutput()` Returns a OutputHandler object providing information whether a task's output was created successfully and when it was last modified.
`java.lang.String` | `getPath()` Returns the path of the task, which is a fully qualified name for the task.
`Project` | `getProject()` Returns the `Project` which this task belongs to.
`TaskDependency` | `getTaskDependencies()` Returns a `TaskDependency` which contains all the tasks that this task depends on.
`boolean` | `hasProperty(java.lang.String propertyName)` Determines if this task has the given property.
`Task` | `leftShift(groovy.lang.Closure action)` Adds the given closure to the end of this task's action list.
`void` | `onlyIf(groovy.lang.Closure onlyIfClosure)` Execute the task only if the closure returns true.
`void` | `onlyIf(Spec<? super Task> onlyIfSpec)` Execute the task only if the spec is satisfied.
`java.lang.Object` | `property(java.lang.String propertyName)` Returns the value of the given property of this task.
`void` | `setActions(java.util.List<Action<? super Task>> actions)` Sets the sequence of `TaskAction` objects which will be executed by this task.
`void` | `setDependsOn(java.lang.Iterable<?> dependsOnTasks)` Sets the dependencies of this task.
`void` | `setDescription(java.lang.String description)` Adds a text to describe what the task does to the user of the build.
`void` | `setEnabled(boolean enabled)` Set the enabled state of a task.
`void` | `setProperty(java.lang.String name, java.lang.Object value)` Sets a property of this task.

Methods inherited from interface java.lang.Comparable
`compareTo`

Field Detail

### TASK_NAME

    static final java.lang.String TASK_NAME

See Also:
  Constant Field Values

### TASK_DESCRIPTION

    static final java.lang.String TASK_DESCRIPTION

See Also:
  Constant Field Values

### TASK_TYPE

    static final java.lang.String TASK_TYPE

See Also:
  Constant Field Values

### TASK_DEPENDS_ON

    static final java.lang.String TASK_DEPENDS_ON

See Also:
  Constant Field Values

### TASK_OVERWRITE

    static final java.lang.String TASK_OVERWRITE

See Also:
  Constant Field Values

### TASK_ACTION

    static final java.lang.String TASK_ACTION

See Also:
  Constant Field Values

### AUTOSKIP_PROPERTY_PREFIX

    static final java.lang.String AUTOSKIP_PROPERTY_PREFIX

See Also:
  Constant Field Values

Method Detail

### getName

    java.lang.String getName()

  Returns the name of this task. The name uniquely identifies the task within its `Project`.

  Returns:
    The name of the task. Never returns null.

### getProject

    Project getProject()

  Returns the `Project` which this task belongs to.

  Returns:
    The project this task belongs to. Never returns null.

### getActions

    java.util.List<Action<? super Task>> getActions()

  Returns the sequence of `TaskAction` objects which will be executed by this task, in the order of execution.

  Returns:
    The task actions in the order they are executed. Returns an empty list if this task has no actions.

### setActions

    void setActions(java.util.List<Action<? super Task>> actions)

  Sets the sequence of `TaskAction` objects which will be executed by this task.

  Parameters:
    `actions` - The actions.

### getTaskDependencies

    TaskDependency getTaskDependencies()

  Returns a `TaskDependency` which contains all the tasks that this task depends on.

  Returns:
    The dependencies of this task. Never returns null.

### getDependsOn

    java.util.Set<java.lang.Object> getDependsOn()

  Returns the dependencies of this task.

  Returns:
    The dependencies of this task. Returns an empty set if this task has no dependencies.

### setDependsOn

    void setDependsOn(java.lang.Iterable<?> dependsOnTasks)

  Sets the dependencies of this task. See here for a description of the types of objects which can be used as task dependencies.

  Parameters:
    `dependsOnTasks` - The set of task paths.

### dependsOn

    Task dependsOn(java.lang.Object... paths)

  Adds the given dependencies to this task. See here for a description of the types of objects which can be used as task dependencies.

  Parameters:
    `paths` - The dependencies to add to this task.
  Returns:
    the task object this method is applied to

### onlyIf

    void onlyIf(groovy.lang.Closure onlyIfClosure)

  Execute the task only if the closure returns true. The closure will be evaluated at the task execution time, not during configuration. The closure will be passed a single parameter, this task. The closure will be coerced to a `Spec` of type `Task`.

  If the closure returns false, the task will not execute, but will log a message of 'SKIPPED as onlyIf is false'.

  Typical usage:

  `myTask.onlyIf{ dependsOnTaskDidWork() }`

  Parameters:
    `onlyIfClosure` - code to execute to determine if task should be run
  See Also:
    `getDidWork()`

### onlyIf

    void onlyIf(Spec<? super Task> onlyIfSpec)

  Execute the task only if the spec is satisfied. The spec will be evaluated at task execution time, not during configuration.

  If the Spec is not satisfied, the task will not execute, but will log a message of 'SKIPPED as onlyIf is false'.

  Typical usage (from Java):

      myTask.onlyIf(new Spec() {
          boolean isSatisfiedBy(Task task) {
             return task.dependsOnTaskDidWork();
          }
       });

  Parameters:
    `onlyIfSpec` - specifies if a task should be run
  See Also:
    `getDidWork()`

### getDidWork

    boolean getDidWork()

  Checks if the task actually did any work. Even if a Task executes, it may determine that it has nothing to do. For example, the Compile task may determine that source files have not changed since the last time a the task was run.

  Returns:
    true if this task did any work

### getExecuted

    boolean getExecuted()

  Returns true if this task has been executed.

  Returns:
    true if this task has been executed already, false otherwise.

### getPath

    java.lang.String getPath()

  Returns the path of the task, which is a fully qualified name for the task. The path of a task is the path of its `Project` plus the name of the task, separated by `:`.

  Returns:
    the path of the task, which is equal to the path of the project plus the name of the task.

### doFirst

    Task doFirst(Action<? super Task> action)

  Adds the given `TaskAction` to the beginning of this task's action list.

  Parameters:
    `action` - The action to add
  Returns:
    the task object this method is applied to

### doFirst

    Task doFirst(groovy.lang.Closure action)

  Adds the given closure to the beginning of this task's action list. The closure is passed this task as a parameter when executed.

  Parameters:
    `action` - The action closure to execute.
  Returns:
    This task.

### doLast

    Task doLast(Action<? super Task> action)

  Adds the given `TaskAction` to the end of this task's action list.

  Parameters:
    `action` - The action to add.
  Returns:
    the task object this method is applied to

### doLast

    Task doLast(groovy.lang.Closure action)

  Adds the given closure to the end of this task's action list. The closure is passed this task as a parameter when executed.

  Parameters:
    `action` - The action closure to execute.
  Returns:
    This task.

### leftShift

    Task leftShift(groovy.lang.Closure action)

  Adds the given closure to the end of this task's action list. The closure is passed this task as a parameter when executed. You can call this method from your build script using the << left shift operator.

  Parameters:
    `action` - The action closure to execute.
  Returns:
    This task.

### deleteAllActions

    Task deleteAllActions()

  Removes all the actions of this task.

  Returns:
    the task object this method is applied to

### getEnabled

    boolean getEnabled()

  Returns if this task is enabled or not.

  See Also:
    `setEnabled(boolean)`

### getOutput

    org.gradle.execution.OutputHandler getOutput()

  Returns a OutputHandler object providing information whether a task's output was created successfully and when it was last modified.

### setEnabled

    void setEnabled(boolean enabled)

  Set the enabled state of a task. If a task is disabled none of the its actions are executed. Note that disabling a task does not prevent the execution of the tasks which this task depends on.

  Parameters:
    `enabled` - The enabled state of this task (true or false)

### configure

    Task configure(groovy.lang.Closure configureClosure)

  Applies the statements of the closure against this task object. The delegate object for the closure is set to this task.

  Parameters:
    `configureClosure` - The closure to be applied (can be null).
  Returns:
    This task

### getAnt

    AntBuilder getAnt()

  Returns the `AntBuilder` for this task. You can use this in your build file to execute ant tasks.

  Returns:
    The `AntBuilder`

### getLogger

    Logger getLogger()

  Returns the logger for this task. You can use this in your build file to write log messages.

  Returns:
    The logger. Never returns null.

### disableStandardOutputCapture

    Task disableStandardOutputCapture()

  Disables redirection of standard output during task execution. By default redirection is enabled.

  Returns:
    this
  See Also:
    `captureStandardOutput(org.gradle.api.logging.LogLevel)`

### captureStandardOutput

    Task captureStandardOutput(LogLevel level)

  Enables redirection of standard output during task execution to the logging system. By default redirection is enabled and the task output is redirected to the QUIET level. System.err is always redirected to the ERROR level. An exception is thrown, if this method is called during the execution of the task For more fine-grained control on redirecting standard output see `StandardOutputLogging`.

  Parameters:
    `level` - The level standard out should be logged to.
  Returns:
    this
  See Also:
    `disableStandardOutputCapture()`

### property

    java.lang.Object property(java.lang.String propertyName)
                              throws groovy.lang.MissingPropertyException

  Returns the value of the given property of this task. This method locates a property as follows:
  1. If this task object has a property with the given name, return the value of the property.
  2. If this task has an additional property with the given name, return the value of the property.
  3. If this task's convention object has a property with the given name, return the value of the property.
  4. If not found, throw `MissingPropertyException`

  Parameters:
    `propertyName` - The name of the property.
  Returns:
    The value of the property, possibly null.
  Throws:
    `groovy.lang.MissingPropertyException` - When the given property is unknown.

### hasProperty

    boolean hasProperty(java.lang.String propertyName)

  Determines if this task has the given property. See here for details of the properties which are available for a task.

  Parameters:
    `propertyName` - The name of the property to locate.
  Returns:
    True if this project has the given property, false otherwise.

### setProperty

    void setProperty(java.lang.String name,
                     java.lang.Object value)

  Sets a property of this task. This method searches for a property with the given name in the following locations, and sets the property on the first location where it finds the property.

  1. The task object itself. For example, the `enabled` project property.
  2. The task's convention object.
  3. The task's additional properties.

  If the property is not found in any of these locations, it is added to the project's additional properties.

  Parameters:
    `name` - The name of the property
    `value` - The value of the property

### getConvention

    Convention getConvention()

  Returns the `Convention` object for this task. A `Plugin` can use the convention object to contribute properties and methods to this task.

  Returns:
    The convention object. Never returns null.

### getDescription

    java.lang.String getDescription()

  Returns the description of a task.

  See Also:
    `setDescription(String)`

### setDescription

    void setDescription(java.lang.String description)

  Adds a text to describe what the task does to the user of the build. The description will be displayed when `gradle -t` is called.

  Parameters:
    `description` - The description of the task. Might be null.

### dependsOnTaskDidWork

    boolean dependsOnTaskDidWork()

  Checks if any of the tasks that this task depends on `didWork`.

  Returns:
    true if any task this task depends on did work.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD